// MFC GosView.h : interface of the CMFCGosView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MFCGOSVIEW_H__931C70EC_5D05_11D2_8408_00A0C933BCAC__INCLUDED_)
#define AFX_MFCGOSVIEW_H__931C70EC_5D05_11D2_8408_00A0C933BCAC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <GameOS\GameOS.hpp>
#include <ElementRenderer\ElementRenderer.hpp>
#include <ElementRenderer\Element.hpp>
#include <MLR\MLR.hpp>

#include"MFC GOSDoc.h"

#include"ErfDataTree.h"


class CMFCGosView : public CView
{
protected: // create from serialization only
	CMFCGosView();
	DECLARE_DYNCREATE(CMFCGosView)
		
		// Attributes
public:
	CMFCGosDoc* GetDocument();
	CImageList *imlist;
	CErfDataTree *erftree;
	static CMFCGosView *Instance;
	// Operations
public:
	
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMFCGosView)
public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual BOOL DestroyWindow();
protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL
	
	// Implementation
public:
	void AddErfBranch(HTREEITEM node, ElementRenderer::Element *elmt);
	void AddErfBranch(HTREEITEM node, MidLevelRenderer::MLRPrimitiveBase *prim);
	void OnExpandAll();
  void OnCollapseAll();
	void ExpandTreeData(CErfDataTree * tree, HTREEITEM hItem, BOOL expand);
	
	
	virtual ~CMFCGosView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	
protected:
	
	// Generated message map functions
protected:
	//{{AFX_MSG(CMFCGosView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnFileImport();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MFC GosView.cpp
inline CMFCGosDoc* CMFCGosView::GetDocument()
{ return (CMFCGosDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MFCGOSVIEW_H__931C70EC_5D05_11D2_8408_00A0C933BCAC__INCLUDED_)
